-------------------------------------------------------------------------------
--   ____  ____
--  /   /\/   /
-- /___/  \  /    Vendor: Xilinx
-- \   \   \/     Version : 2.2
--  \   \         Application : 7 Series FPGAs Transceivers Wizard
--  /   /         Filename : WHITERABBIT_GTPE_2PCHANNEL_WRAPPER_GT.vhd
-- /___/   /\
-- \   \  /  \
--  \___\/\___\
--
--
-- Module WHITERABBIT_GTPE_2PCHANNEL_WRAPPER_GT (a GT Wrapper)
-- Generated by Xilinx 7 Series FPGAs Transceivers Wizard
--
--
-- (c) Copyright 2010-2012 Xilinx, Inc. All rights reserved.
--
-- This file contains confidential and proprietary information
-- of Xilinx, Inc. and is protected under U.S. and
-- international copyright and other intellectual property
-- laws.
--
-- DISCLAIMER
-- This disclaimer is not a license and does not grant any
-- rights to the materials distributed herewith. Except as
-- otherwise provided in a valid license issued to you by
-- Xilinx, and to the maximum extent permitted by applicable
-- law: (1) THESE MATERIALS ARE MADE AVAILABLE "AS IS" AND
-- WITH ALL FAULTS, AND XILINX HEREBY DISCLAIMS ALL WARRANTIES
-- AND CONDITIONS, EXPRESS, IMPLIED, OR STATUTORY, INCLUDING
-- BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, NON-
-- INFRINGEMENT, OR FITNESS FOR ANY PARTICULAR PURPOSE; and
-- (2) Xilinx shall not be liable (whether in contract or tort,
-- including negligence, or under any other theory of
-- liability) for any loss or damage of any kind or nature
-- related to, arising under or in connection with these
-- materials, including for any direct, or any indirect,
-- special, incidental, or consequential loss or damage
-- (including loss of data, profits, goodwill, or any type of
-- loss or damage suffered as a result of any action brought
-- by a third party) even if such damage or loss was
-- reasonably foreseeable or Xilinx had been advised of the
-- possibility of the same.
--
-- CRITICAL APPLICATIONS
-- Xilinx products are not designed or intended to be fail-
-- safe, or for use in any application requiring fail-safe
-- performance, such as life-support or safety devices or
-- systems, Class III medical devices, nuclear facilities,
-- applications related to the deployment of airbags, or any
-- other applications that could lead to death, personal
-- injury, or severe property or environmental damage
-- (individually and collectively, "Critical
-- Applications"). Customer assumes the sole risk and
-- liability of any use of Xilinx products in Critical
-- Applications, subject only to applicable laws and
-- regulations governing limitations on product liability.
--
-- THIS COPYRIGHT NOTICE AND DISCLAIMER MUST BE RETAINED AS
-- PART OF THIS FILE AT ALL TIMES.


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
library UNISIM;
use UNISIM.VCOMPONENTS.ALL;


--***************************** Entity Declaration ****************************

entity WHITERABBIT_GTPE_2PCHANNEL_WRAPPER_GT is
generic
(
    -- Simulation attributes
    WRAPPER_SIM_GTRESET_SPEEDUP    : string   := "false" -- Set to "true" to speed up sim reset
);
port
(

    SYS_CLK_IN                               : in   std_logic;  --Ref clock used for TX phase align. eml.

    --------------------------- TX Phase Align Ports --------------------------
    run_tx_phalignment_i                     : in   std_logic;
    rst_tx_phalignment_i                     : in   std_logic;
    tx_phalignment_done_o                    : out  std_logic;


    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT0  (X0Y0)
    --____________________________CHANNEL PORTS________________________________
    ---------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
    GT0_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT0_DRPCLK_IN                           : in   std_logic;
    GT0_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT0_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT0_DRPEN_IN                            : in   std_logic;
    GT0_DRPRDY_OUT                          : out  std_logic;
    GT0_DRPWE_IN                            : in   std_logic;
    ------------------------------- Eye Scan Ports -----------------------------
    GT0_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------ Loopback and Powerdown Ports ----------------------
    GT0_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    ------------------------------- Receive Ports ------------------------------
    GT0_RXUSERRDY_IN                        : in   std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    GT0_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT0_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    GT0_RXBYTEISALIGNED_OUT                 : out  std_logic;
    GT0_RXSLIDE_IN                          : in   std_logic;
    GT0_RXCOMMADET_OUT                      : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    GT0_GTRXRESET_IN                        : in   std_logic;
    GT0_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    GT0_RXOUTCLK_OUT                        : out  std_logic;
    GT0_RXPMARESET_IN                       : in   std_logic;
    GT0_RXUSRCLK_IN                         : in   std_logic;
    GT0_RXUSRCLK2_IN                        : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GT0_GTPRXN_IN                           : in   std_logic;
    GT0_GTPRXP_IN                           : in   std_logic;
    GT0_RXCDRLOCK_OUT                       : out  std_logic;
    GT0_RXCDRRESET_IN                       : in   std_logic;  --eml. Added.
    GT0_RXELECIDLE_OUT                      : out  std_logic;
    GT0_RXLPMHFHOLD_IN                      : in   std_logic;
    GT0_RXLPMLFHOLD_IN                      : in   std_logic;
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GT0_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------------- Transmit Ports -----------------------------
    GT0_TXUSERRDY_IN                        : in   std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    GT0_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT0_GTTXRESET_IN                        : in   std_logic;
    GT0_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    GT0_TXOUTCLK_OUT                        : out  std_logic;
    GT0_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT0_TXOUTCLKPCS_OUT                     : out  std_logic;
    GT0_TXUSRCLK_IN                         : in   std_logic;
    GT0_TXUSRCLK2_IN                        : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT0_GTPTXN_OUT                          : out  std_logic;
    GT0_GTPTXP_OUT                          : out  std_logic;
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GT0_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT0_TXPRBSSEL_IN                       : in   std_logic_vector(2 downto 0);

    --GT1  (X0Y1)
    --____________________________CHANNEL PORTS________________________________
    ---------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
    GT1_DRPADDR_IN                          : in   std_logic_vector(8 downto 0);
    GT1_DRPCLK_IN                           : in   std_logic;
    GT1_DRPDI_IN                            : in   std_logic_vector(15 downto 0);
    GT1_DRPDO_OUT                           : out  std_logic_vector(15 downto 0);
    GT1_DRPEN_IN                            : in   std_logic;
    GT1_DRPRDY_OUT                          : out  std_logic;
    GT1_DRPWE_IN                            : in   std_logic;
    ------------------------------- Eye Scan Ports -----------------------------
    GT1_EYESCANDATAERROR_OUT                : out  std_logic;
    ------------------------ Loopback and Powerdown Ports ----------------------
    GT1_LOOPBACK_IN                         : in   std_logic_vector(2 downto 0);
    ------------------------------- Receive Ports ------------------------------
    GT1_RXUSERRDY_IN                        : in   std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    GT1_RXCHARISK_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXDISPERR_OUT                       : out  std_logic_vector(1 downto 0);
    GT1_RXNOTINTABLE_OUT                    : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    GT1_RXBYTEISALIGNED_OUT                 : out  std_logic;
    GT1_RXSLIDE_IN                          : in   std_logic;
    GT1_RXCOMMADET_OUT                      : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    GT1_GTRXRESET_IN                        : in   std_logic;
    GT1_RXDATA_OUT                          : out  std_logic_vector(15 downto 0);
    GT1_RXOUTCLK_OUT                        : out  std_logic;
    GT1_RXPMARESET_IN                       : in   std_logic;
    GT1_RXUSRCLK_IN                         : in   std_logic;
    GT1_RXUSRCLK2_IN                        : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GT1_GTPRXN_IN                           : in   std_logic;
    GT1_GTPRXP_IN                           : in   std_logic;
    GT1_RXCDRLOCK_OUT                       : out  std_logic;
    GT1_RXCDRRESET_IN                       : in   std_logic;  --eml. Added
    GT1_RXELECIDLE_OUT                      : out  std_logic;
    GT1_RXLPMHFHOLD_IN                      : in   std_logic;
    GT1_RXLPMLFHOLD_IN                      : in   std_logic;
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    GT1_RXRESETDONE_OUT                     : out  std_logic;
    ------------------------------- Transmit Ports -----------------------------
    GT1_TXUSERRDY_IN                        : in   std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    GT1_TXCHARISK_IN                        : in   std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GT1_GTTXRESET_IN                        : in   std_logic;
    GT1_TXDATA_IN                           : in   std_logic_vector(15 downto 0);
    GT1_TXOUTCLK_OUT                        : out  std_logic;
    GT1_TXOUTCLKFABRIC_OUT                  : out  std_logic;
    GT1_TXOUTCLKPCS_OUT                     : out  std_logic;
    GT1_TXUSRCLK_IN                         : in   std_logic;
    GT1_TXUSRCLK2_IN                        : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GT1_GTPTXN_OUT                          : out  std_logic;
    GT1_GTPTXP_OUT                          : out  std_logic;
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    GT1_TXRESETDONE_OUT                     : out  std_logic;
    ------------------ Transmit Ports - pattern Generator Ports ----------------
    GT1_TXPRBSSEL_IN                        : in   std_logic_vector(2 downto 0);

    --____________________________COMMON PORTS________________________________
    ---------------------------- Common Block - Ports --------------------------
    GT0_GTREFCLK0_IN                        : in   std_logic;
    GT0_PLL0LOCK_OUT                        : out  std_logic;
    GT0_PLL0LOCKDETCLK_IN                   : in   std_logic;
    GT0_PLL0REFCLKLOST_OUT                  : out  std_logic;
    GT0_PLL0RESET_IN                        : in   std_logic
);


end WHITERABBIT_GTPE_2PCHANNEL_WRAPPER_GT;

architecture RTL of WHITERABBIT_GTPE_2PCHANNEL_WRAPPER_GT is

    attribute CORE_GENERATION_INFO : string;
    attribute CORE_GENERATION_INFO of RTL : architecture is "WHITERABBIT_GTPE_2PCHANNEL_WRAPPER_GT,gtwizard_v2_2,{protocol_file=gigabit_ethernet_CC}";


--***********************************Parameter Declarations********************

    constant DLY : time := 1 ns;

--***************************** Signal Declarations *****************************

    -- ground and tied_to_vcc_i signals
    signal  tied_to_ground_i                :   std_logic;
    signal  tied_to_ground_vec_i            :   std_logic_vector(63 downto 0);
    signal  tied_to_vcc_i                   :   std_logic;
    signal   gt0_pll0outclk_i       :   std_logic;

    signal   gt0_pll0outrefclk_i    :   std_logic;

    signal   gt0_pll1outclk_i       :   std_logic;
    signal   gt0_pll1outrefclk_i    :   std_logic;


    signal  gt0_mgtrefclktx_i           :   std_logic_vector(1 downto 0);
    signal  gt0_mgtrefclkrx_i           :   std_logic_vector(1 downto 0);

    signal  gt1_mgtrefclktx_i           :   std_logic_vector(1 downto 0);
    signal  gt1_mgtrefclkrx_i           :   std_logic_vector(1 downto 0);


    signal   gt0_pll0clk_i       :   std_logic;
    signal   gt0_pll0refclk_i    :   std_logic := '0';
    signal   gt0_pll1clk_i       :   std_logic;
    signal   gt0_pll1refclk_i    :   std_logic;
    signal   gt1_pll0clk_i       :   std_logic;
    signal   gt1_pll0refclk_i    :   std_logic := '0';
    signal   gt1_pll1clk_i       :   std_logic;
    signal   gt1_pll1refclk_i    :   std_logic;

    signal   gt0_rst_i           :   std_logic;
    signal   gt1_rst_i           :   std_logic;



    --------------------------- TX Buffer Bypass Signals --------------------
    signal  s_TXDLYEN                 : std_logic_vector(1 downto 0);
    signal  s_TXDLYSRESET             : std_logic_vector(1 downto 0);
    signal  s_TXDLYSRESETDONE         : std_logic_vector(1 downto 0);
    signal  s_TXPHINIT                : std_logic_vector(1 downto 0);
    signal  s_TXPHINITDONE            : std_logic_vector(1 downto 0);
    signal  s_TXPHALIGN               : std_logic_vector(1 downto 0);
    signal  s_TXPHALIGNDONE           : std_logic_vector(1 downto 0);
    signal  s_run_tx_phalignment      : std_logic;
    signal  s_rst_tx_phalignment      : std_logic;
    signal  s_gt0_tx_phalignment_done : std_logic;


    signal  s_gt0_txphaligndone             : std_logic;
    signal  s_gt0_txdlysreset               : std_logic;
    signal  s_gt0_txdlysresetdone           : std_logic;
    signal  s_gt0_txphdlyreset              : std_logic;
    signal  s_gt0_txphalignen               : std_logic;
    signal  s_gt0_txdlyen                   : std_logic;
    signal  s_gt0_txphalign                 : std_logic;
    signal  s_gt0_txphinit                  : std_logic;
    signal  s_gt0_txphinitdone              : std_logic;
    signal  s_gt0_run_tx_phalignment        : std_logic;
    signal  s_gt0_rst_tx_phalignment        : std_logic;

    signal  s_gt0_txsyncallin               : std_logic;
    signal  s_gt0_txsyncin                  : std_logic;
    signal  s_gt0_txsyncmode                : std_logic;
    signal  s_gt0_txsyncout                 : std_logic;
    signal  s_gt0_txsyncdone                : std_logic;


    signal  s_gt1_txphaligndone             : std_logic;
    signal  s_gt1_txdlysreset               : std_logic;
    signal  s_gt1_txdlysresetdone           : std_logic;
    signal  s_gt1_txphdlyreset              : std_logic;
    signal  s_gt1_txphalignen               : std_logic;
    signal  s_gt1_txdlyen                   : std_logic;
    signal  s_gt1_txphalign                 : std_logic;
    signal  s_gt1_txphinit                  : std_logic;
    signal  s_gt1_txphinitdone              : std_logic;
    signal  s_gt1_run_tx_phalignment        : std_logic;
    signal  s_gt1_rst_tx_phalignment        : std_logic;
    signal  s_gt1_txsyncallin               : std_logic;
    signal  s_gt1_txsyncin                  : std_logic;
    signal  s_gt1_txsyncmode                : std_logic;
    signal  s_gt1_txsyncout                 : std_logic;
    signal  s_gt1_txsyncdone                : std_logic;

--*************************** Component Declarations **************************
component GTPE_CHANNEL_GT
generic
(
    -- Simulation attributes
    GT_SIM_GTRESET_SPEEDUP    : string := "false";
    TXSYNC_OVRD_IN            : bit    := '0';
    TXSYNC_MULTILANE_IN       : bit    := '0'
);
port
(
     RST_IN                             : in   std_logic;   -- Added. eml.

    ---------------- Transmit Ports - TX Buffer Bypass Ports -------------------
    txdlyen_in                          : in   std_logic;
    txdlysreset_in                      : in   std_logic;
    txdlysresetdone_out                 : out  std_logic;
    txphalign_in                        : in   std_logic;
    txphaligndone_out                   : out  std_logic;
    txphalignen_in                      : in   std_logic;
    txphdlyreset_in                     : in   std_logic;
    txphinit_in                         : in   std_logic;
    txphinitdone_out                    : out  std_logic;

    ---------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
    DRPADDR_IN                              : in   std_logic_vector(8 downto 0);
    DRPCLK_IN                               : in   std_logic;
    DRPDI_IN                                : in   std_logic_vector(15 downto 0);
    DRPDO_OUT                               : out  std_logic_vector(15 downto 0);
    DRPEN_IN                                : in   std_logic;
    DRPRDY_OUT                              : out  std_logic;
    DRPWE_IN                                : in   std_logic;

    DRP_BUSY_OUT                            : out  std_logic;   -- Added. eml.
    ----------------------------- Channel PLL Ports ----------------------------
    PLL0CLK_IN                              : in   std_logic;
    PLL0REFCLK_IN                           : in   std_logic;
    PLL1CLK_IN                              : in   std_logic;
    PLL1REFCLK_IN                           : in   std_logic;
    ------------------------------- Eye Scan Ports -----------------------------
    EYESCANDATAERROR_OUT                    : out  std_logic;
    ------------------------ Loopback and Powerdown Ports ----------------------
    LOOPBACK_IN                             : in   std_logic_vector(2 downto 0);
    ------------------------------- Receive Ports ------------------------------
    RXUSERRDY_IN                            : in   std_logic;
    ----------------------- Receive Ports - 8b10b Decoder ----------------------
    RXCHARISK_OUT                           : out  std_logic_vector(1 downto 0);
    RXDISPERR_OUT                           : out  std_logic_vector(1 downto 0);
    RXNOTINTABLE_OUT                        : out  std_logic_vector(1 downto 0);
    --------------- Receive Ports - Comma Detection and Alignment --------------
    RXBYTEISALIGNED_OUT                     : out  std_logic;
    RXSLIDE_IN                              : in   std_logic;
    RXCOMMADET_OUT                          : out  std_logic;
    ------------------- Receive Ports - RX Data Path interface -----------------
    GTRXRESET_IN                            : in   std_logic;
    RXDATA_OUT                              : out  std_logic_vector(15 downto 0);
    RXOUTCLK_OUT                            : out  std_logic;
    RXPMARESET_IN                           : in   std_logic;
    RXUSRCLK_IN                             : in   std_logic;
    RXUSRCLK2_IN                            : in   std_logic;
    ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
    GTPRXN_IN                               : in   std_logic;
    GTPRXP_IN                               : in   std_logic;
    RXCDRRESET_IN                           : in   std_logic;	--eml. Added
    RXCDRLOCK_OUT                           : out  std_logic;
    RXELECIDLE_OUT                          : out  std_logic;
    RXLPMHFHOLD_IN                          : in   std_logic;
    RXLPMLFHOLD_IN                          : in   std_logic;
    ------------------------ Receive Ports - RX PLL Ports ----------------------
    RXRESETDONE_OUT                         : out  std_logic;
    ------------------------------- Transmit Ports -----------------------------
    TXUSERRDY_IN                            : in   std_logic;
    ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
    TXCHARISK_IN                            : in   std_logic_vector(1 downto 0);
    ------------------ Transmit Ports - TX Data Path interface -----------------
    GTTXRESET_IN                            : in   std_logic;
    TXDATA_IN                               : in   std_logic_vector(15 downto 0);
    TXOUTCLK_OUT                            : out  std_logic;
    TXOUTCLKFABRIC_OUT                      : out  std_logic;
    TXOUTCLKPCS_OUT                         : out  std_logic;
    TXUSRCLK_IN                             : in   std_logic;
    TXUSRCLK2_IN                            : in   std_logic;
    ---------------- Transmit Ports - TX Driver and OOB signaling --------------
    GTPTXN_OUT                              : out  std_logic;
    GTPTXP_OUT                              : out  std_logic;
    ----------------------- Transmit Ports - TX PLL Ports ----------------------
    TXRESETDONE_OUT                         : out  std_logic;

    ------------------ Transmit Ports - pattern Generator Ports ----------------
    TXPRBSSEL_IN                            : in   std_logic_vector(2 downto 0)
);
end component;


component gtp2p_wizard_TX_MANUAL_PHASE_ALIGN
  Generic( NUMBER_OF_LANES          : integer range 1 to 32:= 4;  -- Number of lanes that are controlled using this FSM.
           MASTER_LANE_ID           : integer range 0 to 31:= 0   -- Number of the lane which is considered the master in manual phase-alignment
         );

    Port ( STABLE_CLOCK             : in  STD_LOGIC;              --Stable Clock, either a stable clock from the PCB
                                                                  --or reference-clock present at startup.
           RESET_PHALIGNMENT        : in  STD_LOGIC;
           RUN_PHALIGNMENT          : in  STD_LOGIC;
           PHASE_ALIGNMENT_DONE     : out STD_LOGIC := '0';       -- Manual phase-alignment performed sucessfully
           TXDLYSRESET              : out STD_LOGIC_VECTOR(NUMBER_OF_LANES-1 downto 0) := (others=> '0');
           TXDLYSRESETDONE          : in  STD_LOGIC_VECTOR(NUMBER_OF_LANES-1 downto 0);
           TXPHINIT                 : out STD_LOGIC_VECTOR(NUMBER_OF_LANES-1 downto 0) := (others=> '0');
           TXPHINITDONE             : in  STD_LOGIC_VECTOR(NUMBER_OF_LANES-1 downto 0);
           TXPHALIGN                : out STD_LOGIC_VECTOR(NUMBER_OF_LANES-1 downto 0) := (others=> '0');
           TXPHALIGNDONE            : in  STD_LOGIC_VECTOR(NUMBER_OF_LANES-1 downto 0);
           TXDLYEN                  : out STD_LOGIC_VECTOR(NUMBER_OF_LANES-1 downto 0) := (others=> '0')
           );
end component;


    constant PLL0_FBDIV_IN      :   integer := 4;
    constant PLL1_FBDIV_IN      :   integer := 1;
    constant PLL0_FBDIV_45_IN   :   integer := 5;
    constant PLL1_FBDIV_45_IN   :   integer := 4;
    constant PLL0_REFCLK_DIV_IN :   integer := 1;
    constant PLL1_REFCLK_DIV_IN :   integer := 1;

--********************************* Main Body of Code**************************

begin

    tied_to_ground_i                    <= '0';
    tied_to_ground_vec_i(63 downto 0)   <= (others => '0');
    tied_to_vcc_i                       <= '1';

--The PLL outputs are the same for the two GTPEs.

    gt0_rst_i        <= GT0_PLL0RESET_IN;
    gt1_rst_i        <= GT0_PLL0RESET_IN;

    gt0_pll0clk_i    <= gt0_pll0outclk_i;
    gt0_pll0refclk_i <= gt0_pll0outrefclk_i;
    gt0_pll1clk_i    <= gt0_pll1outclk_i;
    gt0_pll1refclk_i <= gt0_pll1outrefclk_i;
    gt1_pll0clk_i    <= gt0_pll0outclk_i;
    gt1_pll0refclk_i <= gt0_pll0outrefclk_i;
    gt1_pll1clk_i    <= gt0_pll1outclk_i;
    gt1_pll1refclk_i <= gt0_pll1outrefclk_i;
    --------------------------- GT Instances  -------------------------------
    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT0  (X0Y0)
    gt0_gtpe_2pchannel : GTPE_CHANNEL_GT
    generic map
    (
        -- Simulation attributes
        GT_SIM_GTRESET_SPEEDUP => WRAPPER_SIM_GTRESET_SPEEDUP,
        TXSYNC_OVRD_IN         => ('1'),  -- Before 0 but it's set to high in the Vivado wizard.
        TXSYNC_MULTILANE_IN    => ('0')
    )
    port map
    (

        RST_IN                          =>      gt0_rst_i,  -- Added. eml.


        ---------------- Transmit Ports - TX Buffer Bypass Ports -------------------
        txdlyen_in                     => s_gt0_txdlyen,
        txdlysreset_in                 => s_gt0_txdlysreset,
        txdlysresetdone_out            => s_gt0_txdlysresetdone,
        txphalign_in                   => s_gt0_txphalign,
        txphaligndone_out              => s_gt0_txphaligndone,
        txphalignen_in                 => s_gt0_txphalignen,
        txphdlyreset_in                => s_gt0_txphdlyreset,
        txphinit_in                    => s_gt0_txphinit,
        txphinitdone_out               => s_gt0_txphinitdone,

        ---------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
        DRPADDR_IN                      =>      GT0_DRPADDR_IN,
        DRPCLK_IN                       =>      GT0_DRPCLK_IN,
        DRPDI_IN                        =>      GT0_DRPDI_IN,
        DRPDO_OUT                       =>      GT0_DRPDO_OUT,
        DRPEN_IN                        =>      GT0_DRPEN_IN,
        DRPRDY_OUT                      =>      GT0_DRPRDY_OUT,
        DRPWE_IN                        =>      GT0_DRPWE_IN,
        DRP_BUSY_OUT                    =>      open,           -- Open by now. eml.
        ----------------------------- Channel PLL Ports ----------------------------
        PLL0CLK_IN                      =>      gt0_pll0clk_i,
        PLL0REFCLK_IN                   =>      gt0_pll0refclk_i,
        PLL1CLK_IN                      =>      gt0_pll1clk_i,
        PLL1REFCLK_IN                   =>      gt0_pll1refclk_i,
        ------------------------------- Eye Scan Ports -----------------------------
        EYESCANDATAERROR_OUT            =>      GT0_EYESCANDATAERROR_OUT,
        ------------------------ Loopback and Powerdown Ports ----------------------
        LOOPBACK_IN                     =>      GT0_LOOPBACK_IN,
        ------------------------------- Receive Ports ------------------------------
        RXUSERRDY_IN                    =>      GT0_RXUSERRDY_IN,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        RXCHARISK_OUT                   =>      GT0_RXCHARISK_OUT,
        RXDISPERR_OUT                   =>      GT0_RXDISPERR_OUT,
        RXNOTINTABLE_OUT                =>      GT0_RXNOTINTABLE_OUT,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        RXBYTEISALIGNED_OUT             =>      GT0_RXBYTEISALIGNED_OUT,
        RXSLIDE_IN                      =>      GT0_RXSLIDE_IN,
        RXCOMMADET_OUT                  =>      GT0_RXCOMMADET_OUT, --eml. Added.
        ------------------- Receive Ports - RX Data Path interface -----------------
        GTRXRESET_IN                    =>      GT0_GTRXRESET_IN,
        RXDATA_OUT                      =>      GT0_RXDATA_OUT,
        RXOUTCLK_OUT                    =>      GT0_RXOUTCLK_OUT,
        RXPMARESET_IN                   =>      GT0_RXPMARESET_IN,
        RXUSRCLK_IN                     =>      GT0_RXUSRCLK_IN,
        RXUSRCLK2_IN                    =>      GT0_RXUSRCLK2_IN,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTPRXN_IN                       =>      GT0_GTPRXN_IN,
        GTPRXP_IN                       =>      GT0_GTPRXP_IN,
        RXCDRLOCK_OUT                   =>      GT0_RXCDRLOCK_OUT,
        RXCDRRESET_IN                   =>      GT0_RXCDRRESET_IN,  --eml. Added.
        RXELECIDLE_OUT                  =>      GT0_RXELECIDLE_OUT,
        RXLPMHFHOLD_IN                  =>      GT0_RXLPMHFHOLD_IN,
        RXLPMLFHOLD_IN                  =>      GT0_RXLPMLFHOLD_IN,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        RXRESETDONE_OUT                 =>      GT0_RXRESETDONE_OUT,
        ------------------------------- Transmit Ports -----------------------------
        TXUSERRDY_IN                    =>      GT0_TXUSERRDY_IN,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TXCHARISK_IN                    =>      GT0_TXCHARISK_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GTTXRESET_IN                    =>      GT0_GTTXRESET_IN,
        TXDATA_IN                       =>      GT0_TXDATA_IN,
        TXOUTCLK_OUT                    =>      GT0_TXOUTCLK_OUT,
        TXOUTCLKFABRIC_OUT              =>      GT0_TXOUTCLKFABRIC_OUT,
        TXOUTCLKPCS_OUT                 =>      GT0_TXOUTCLKPCS_OUT,
        TXUSRCLK_IN                     =>      GT0_TXUSRCLK_IN,
        TXUSRCLK2_IN                    =>      GT0_TXUSRCLK2_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTPTXN_OUT                      =>      GT0_GTPTXN_OUT,
        GTPTXP_OUT                      =>      GT0_GTPTXP_OUT,
        ----------------------- Transmit Ports - TX PLL Ports ----------------------
        TXRESETDONE_OUT                 =>      GT0_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        TXPRBSSEL_IN                    =>      GT0_TXPRBSSEL_IN

    );

    --_________________________________________________________________________
    --_________________________________________________________________________
    --GT1  (X0Y1)
    gt1_gtpe_2pchannel : GTPE_CHANNEL_GT
    generic map
    (
        -- Simulation attributes
        GT_SIM_GTRESET_SPEEDUP => WRAPPER_SIM_GTRESET_SPEEDUP,
        TXSYNC_OVRD_IN         => ('1'),  -- Before 0 but it's set to high in the Vivado wizard.
        TXSYNC_MULTILANE_IN    => ('0')
    )
    port map
    (

        RST_IN                          =>      gt1_rst_i,	    -- Added. eml.


        ---------------- Transmit Ports - TX Buffer Bypass Ports -------------------
        txdlyen_in                     => s_gt1_txdlyen,
        txdlysreset_in                 => s_gt1_txdlysreset,
        txdlysresetdone_out            => s_gt1_txdlysresetdone,
        txphalign_in                   => s_gt1_txphalign,
        txphaligndone_out              => s_gt1_txphaligndone,
        txphalignen_in                 => s_gt1_txphalignen,
        txphdlyreset_in                => s_gt1_txphdlyreset,
        txphinit_in                    => s_gt1_txphinit,
        txphinitdone_out               => s_gt1_txphinitdone,


        ---------------- Channel - Dynamic Reconfiguration Port (DRP) --------------
        DRPADDR_IN                      =>      GT1_DRPADDR_IN,
        DRPCLK_IN                       =>      GT1_DRPCLK_IN,
        DRPDI_IN                        =>      GT1_DRPDI_IN,
        DRPDO_OUT                       =>      GT1_DRPDO_OUT,
        DRPEN_IN                        =>      GT1_DRPEN_IN,
        DRPRDY_OUT                      =>      GT1_DRPRDY_OUT,
        DRPWE_IN                        =>      GT1_DRPWE_IN,

        DRP_BUSY_OUT                    =>      open,           -- Open by now. eml.
        ----------------------------- Channel PLL Ports ----------------------------
        PLL0CLK_IN                      =>      gt1_pll0clk_i,
        PLL0REFCLK_IN                   =>      gt1_pll0refclk_i,
        PLL1CLK_IN                      =>      gt1_pll1clk_i,
        PLL1REFCLK_IN                   =>      gt1_pll1refclk_i,
        ------------------------------- Eye Scan Ports -----------------------------
        EYESCANDATAERROR_OUT            =>      GT1_EYESCANDATAERROR_OUT,
        ------------------------ Loopback and Powerdown Ports ----------------------
        LOOPBACK_IN                     =>      GT1_LOOPBACK_IN,
        ------------------------------- Receive Ports ------------------------------
        RXUSERRDY_IN                    =>      GT1_RXUSERRDY_IN,
        ----------------------- Receive Ports - 8b10b Decoder ----------------------
        RXCHARISK_OUT                   =>      GT1_RXCHARISK_OUT,
        RXDISPERR_OUT                   =>      GT1_RXDISPERR_OUT,
        RXNOTINTABLE_OUT                =>      GT1_RXNOTINTABLE_OUT,
        --------------- Receive Ports - Comma Detection and Alignment --------------
        RXBYTEISALIGNED_OUT             =>      GT1_RXBYTEISALIGNED_OUT,
        RXSLIDE_IN                      =>      GT1_RXSLIDE_IN,
        RXCOMMADET_OUT                  =>      GT1_RXCOMMADET_OUT,  --eml. added.
        ------------------- Receive Ports - RX Data Path interface -----------------
        GTRXRESET_IN                    =>      GT1_GTRXRESET_IN,
        RXDATA_OUT                      =>      GT1_RXDATA_OUT,
        RXOUTCLK_OUT                    =>      GT1_RXOUTCLK_OUT,
        RXPMARESET_IN                   =>      GT1_RXPMARESET_IN,
        RXUSRCLK_IN                     =>      GT1_RXUSRCLK_IN,
        RXUSRCLK2_IN                    =>      GT1_RXUSRCLK2_IN,
        ------- Receive Ports - RX Driver,OOB signalling,Coupling and Eq.,CDR ------
        GTPRXN_IN                       =>      GT1_GTPRXN_IN,
        GTPRXP_IN                       =>      GT1_GTPRXP_IN,
        RXCDRRESET_IN                   =>      GT1_RXCDRRESET_IN,  --eml. Added.
        RXCDRLOCK_OUT                   =>      GT1_RXCDRLOCK_OUT,
        RXELECIDLE_OUT                  =>      GT1_RXELECIDLE_OUT,
        RXLPMHFHOLD_IN                  =>      GT1_RXLPMHFHOLD_IN,
        RXLPMLFHOLD_IN                  =>      GT1_RXLPMLFHOLD_IN,
        ------------------------ Receive Ports - RX PLL Ports ----------------------
        RXRESETDONE_OUT                 =>      GT1_RXRESETDONE_OUT,
        ------------------------------- Transmit Ports -----------------------------
        TXUSERRDY_IN                    =>      GT1_TXUSERRDY_IN,
        ---------------- Transmit Ports - 8b10b Encoder Control Ports --------------
        TXCHARISK_IN                    =>      GT1_TXCHARISK_IN,
        ------------------ Transmit Ports - TX Data Path interface -----------------
        GTTXRESET_IN                    =>      GT1_GTTXRESET_IN,
        TXDATA_IN                       =>      GT1_TXDATA_IN,
        TXOUTCLK_OUT                    =>      GT1_TXOUTCLK_OUT,
        TXOUTCLKFABRIC_OUT              =>      GT1_TXOUTCLKFABRIC_OUT,
        TXOUTCLKPCS_OUT                 =>      GT1_TXOUTCLKPCS_OUT,
        TXUSRCLK_IN                     =>      GT1_TXUSRCLK_IN,
        TXUSRCLK2_IN                    =>      GT1_TXUSRCLK2_IN,
        ---------------- Transmit Ports - TX Driver and OOB signaling --------------
        GTPTXN_OUT                      =>      GT1_GTPTXN_OUT,
        GTPTXP_OUT                      =>      GT1_GTPTXP_OUT,
        ----------------------- Transmit Ports - TX PLL Ports ----------------------
        TXRESETDONE_OUT                 =>      GT1_TXRESETDONE_OUT,
        ------------------ Transmit Ports - pattern Generator Ports ----------------
        TXPRBSSEL_IN                    =>      GT1_TXPRBSSEL_IN

    );

    --_________________________________________________________________________
    --_________________________________________________________________________
    --_________________________GTPE2_COMMON____________________________________

    gtpe2_common_0_i : GTPE2_COMMON
    generic map
    (
            -- Simulation attributes
            SIM_RESET_SPEEDUP    => WRAPPER_SIM_GTRESET_SPEEDUP,
            SIM_PLL0REFCLK_SEL   => ("001"),
            SIM_PLL1REFCLK_SEL   => ("001"),
            SIM_VERSION          => ("1.0"),

            PLL0_FBDIV           => PLL0_FBDIV_IN     ,	--	4
	         PLL0_FBDIV_45        => PLL0_FBDIV_45_IN  ,	-- 5
	         PLL0_REFCLK_DIV      => PLL0_REFCLK_DIV_IN,	-- 1

	         PLL1_FBDIV           => PLL1_FBDIV_IN     ,	-- 1
	         PLL1_FBDIV_45        => PLL1_FBDIV_45_IN  ,	-- 4
	         PLL1_REFCLK_DIV      => PLL1_REFCLK_DIV_IN,	-- 1


       ------------------COMMON BLOCK Attributes---------------
        BIAS_CFG                                =>     (x"0000000000050001"),  -- according to AR 51369. eml.
        COMMON_CFG                              =>     (x"00000000"),

       ----------------------------PLL Attributes----------------------------
        PLL0_CFG                                =>     (x"01F03DC"),          -- ISE Wizard (x"0B007DB"),
        PLL0_DMON_CFG                           =>     ('0'),
        PLL0_INIT_CFG                           =>     (x"00001E"),
        PLL0_LOCK_CFG                           =>     (x"1E8"),
        PLL1_CFG                                =>     (x"01F03DC"),         -- ISE Wizard (x"0B007DB"),
        PLL1_DMON_CFG                           =>     ('0'),
        PLL1_INIT_CFG                           =>     (x"00001E"),
        PLL1_LOCK_CFG                           =>     (x"1E8"),
        PLL_CLKOUT_CFG                          =>     (x"00"),

       ----------------------------Reserved Attributes----------------------------
        RSVD_ATTR0                              =>     (x"0000"),
        RSVD_ATTR1                              =>     (x"0000")


    )
    port map
    (
	     DMONITOROUT             => open,
        ------------- Common Block  - Dynamic Reconfiguration Port (DRP) -----------
        DRPADDR                         =>      tied_to_ground_vec_i(7 downto 0),
        DRPCLK                          =>      tied_to_ground_i,
        DRPDI                           =>      tied_to_ground_vec_i(15 downto 0),
        DRPDO                           =>      open,
        DRPEN                           =>      tied_to_ground_i,
        DRPRDY                          =>      open,
        DRPWE                           =>      tied_to_ground_i,

        ----------------- Common Block - GTPE2_COMMON Clocking Ports ---------------

        GTEASTREFCLK0                   =>      tied_to_ground_i,
        GTEASTREFCLK1                   =>      tied_to_ground_i,
        GTGREFCLK0                      =>      tied_to_ground_i,
        GTGREFCLK1                      =>      tied_to_ground_i,
        GTREFCLK0                       =>      GT0_GTREFCLK0_IN,  --(Input PLL0REFCLKSEL => "001")
        GTREFCLK1                       =>      tied_to_ground_i,
        GTWESTREFCLK0                   =>      tied_to_ground_i,
        GTWESTREFCLK1                   =>      tied_to_ground_i,
        PLL0OUTCLK                      =>      gt0_pll0outclk_i,			-- Connected straight to the GTP
        PLL0OUTREFCLK                   =>      gt0_pll0outrefclk_i,    -- Connected straight to the GTP
        PLL1OUTCLK                      =>      gt0_pll1outclk_i,
        PLL1OUTREFCLK                   =>      gt0_pll1outrefclk_i,

        -------------------------- Common Block - PLL Ports ------------------------
        PLL0FBCLKLOST                   =>      open,
        PLL0LOCK                        =>      GT0_PLL0LOCK_OUT,
        PLL0LOCKDETCLK                  =>      GT0_PLL0LOCKDETCLK_IN,
        PLL0LOCKEN                      =>      tied_to_vcc_i,
        PLL0PD                          =>      tied_to_ground_i,			-- Power down the PLL
        PLL0REFCLKLOST                  =>      GT0_PLL0REFCLKLOST_OUT,
        PLL0REFCLKSEL                   =>      "001",
        PLL0RESET                       =>      GT0_PLL0RESET_IN,

        PLL1FBCLKLOST                   =>      open,
        PLL1LOCK                        =>      open,
        PLL1LOCKDETCLK                  =>      tied_to_ground_i,
        PLL1LOCKEN                      =>      tied_to_vcc_i,
        PLL1PD                          =>      '1',  -- PLL1 disabled (PD= Power Down)
        PLL1REFCLKLOST                  =>      open,
        PLL1REFCLKSEL                   =>      "001",
        PLL1RESET                       =>      tied_to_ground_i,

        ---------------------------- Common Block - Ports --------------------------
        BGRCALOVRDENB                   =>      tied_to_vcc_i,
        PLLRSVD1                        =>      "0000000000000000",
        PLLRSVD2                        =>      "00000",
        REFCLKOUTMONITOR0               =>      open,
        REFCLKOUTMONITOR1               =>      open,

        ------------------------ Common Block - RX AFE Ports -----------------------
        PMARSVDOUT                      =>      open,
        ----------------------------- Common Block Ports ---------------------------
        BGBYPASSB                       =>      tied_to_vcc_i,
        BGMONITORENB                    =>      tied_to_vcc_i,
        BGPDB                           =>      tied_to_vcc_i,
        BGRCALOVRD                      =>      "11111",    -- ISE Wizard "00000",
        PMARSVD                         =>      "00000000",
        RCALENB                         =>      tied_to_vcc_i

    );

   ----------------------------------------------------------------------------------------------------
	-- TX Manual Phase Align for both GTPs. Component generated by the vivado wizard.
   ----------------------------------------------------------------------------------------------------

   TX_manual_phase : gtp2p_wizard_TX_MANUAL_PHASE_ALIGN
   generic map
   ( NUMBER_OF_LANES	  => 2,
     MASTER_LANE_ID       =>  0
   )
   port map
   (
        STABLE_CLOCK                    =>      SYS_CLK_IN,
        RESET_PHALIGNMENT               =>      s_rst_tx_phalignment,      --TODO
        RUN_PHALIGNMENT                 =>      s_run_tx_phalignment,      --TODO
        PHASE_ALIGNMENT_DONE            =>      s_gt0_tx_phalignment_done,
        TXDLYSRESET                     =>      s_TXDLYSRESET,
        TXDLYSRESETDONE                 =>      s_TXDLYSRESETDONE,
        TXPHINIT                        =>      s_TXPHINIT,
        TXPHINITDONE                    =>      s_TXPHINITDONE,
        TXPHALIGN                       =>      s_TXPHALIGN,
        TXPHALIGNDONE                   =>      s_TXPHALIGNDONE,
        TXDLYEN                         =>      s_TXDLYEN
   );


s_gt0_txphdlyreset     <= tied_to_ground_i;         -- Reset to ground
s_gt0_txphalignen      <= tied_to_vcc_i;
s_gt0_txdlysreset      <= s_TXDLYSRESET(0);
s_gt0_txphinit         <= s_TXPHINIT(0);
s_gt0_txphalign        <= s_TXPHALIGN(0);
s_gt0_txdlyen          <= s_TXDLYEN(0);
s_TXDLYSRESETDONE(0)   <= s_gt0_txdlysresetdone;
s_TXPHINITDONE(0)      <= s_gt0_txphinitdone;
s_TXPHALIGNDONE(0)     <= s_gt0_txphaligndone;

s_gt0_txsyncallin      <= s_gt0_txphaligndone;
s_gt0_txsyncin         <= s_gt0_txsyncout;
s_gt0_txsyncmode       <= tied_to_vcc_i;

s_gt1_txdlysreset      <= s_TXDLYSRESET(1);
s_gt1_txphinit         <= s_TXPHINIT(1);
s_gt1_txphalign        <= s_TXPHALIGN(1);
s_gt1_txphalignen      <= tied_to_vcc_i;
s_gt1_txphdlyreset     <= tied_to_ground_i;		    -- Reset to ground
s_gt1_txdlyen          <= tied_to_ground_i;
s_TXDLYSRESETDONE(1)   <= s_gt1_txdlysresetdone;
s_TXPHINITDONE(1)      <= s_gt1_txphinitdone;
s_TXPHALIGNDONE(1)     <= s_gt1_txphaligndone;

s_gt1_txsyncallin      <= tied_to_ground_i;
s_gt1_txsyncin         <= tied_to_ground_i;
s_gt1_txsyncmode       <= tied_to_ground_i;

s_run_tx_phalignment   <=  run_tx_phalignment_i;		-- Both ports ask for alignment together.
s_rst_tx_phalignment   <=  rst_tx_phalignment_i;


tx_phalignment_done_o    <= s_gt0_tx_phalignment_done;


end RTL;
